package Usuario;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Console;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

import Common.Registro;
import Common.ServicioAutenticacionInterface;
import Common.ServicioCallBackUsuarioInterface;
import Common.ServicioGestorInterface;

public class Usuario {
	private static ServicioAutenticacionInterface servicioAutenticacionInterface;
	private static ServicioGestorInterface servicioGestorInterface;
	private static Console console = System.console ();
	private static BufferedReader reader = new BufferedReader (new InputStreamReader (System.in));
	public static void main (String [] args) throws Exception {
		ServicioCallBackUsuarioImpl servicioCallBackUsuarioImpl = new ServicioCallBackUsuarioImpl ();
		ServicioCallBackUsuarioInterface remoteServicioCallBackUsuario = (ServicioCallBackUsuarioInterface) UnicastRemoteObject.exportObject (servicioCallBackUsuarioImpl, 8888);
		Registry registryServicioCallBackUsuario = LocateRegistry.getRegistry ();
		registryServicioCallBackUsuario.rebind("servicioCallBackUsuario", remoteServicioCallBackUsuario);
		System.out.println ("Servicio callBack preparado, presione enter para terminar");
		System.in.read ();
		registryServicioCallBackUsuario.unbind("servicioCallBackUsuario");
		UnicastRemoteObject.unexportObject (servicioCallBackUsuarioImpl, true);
		System.out.println ("Servicio callBackUsuario cerrado");
		Registry registryAutenticacion = LocateRegistry.getRegistry ();
		servicioAutenticacionInterface = (ServicioAutenticacionInterface) registryAutenticacion.lookup ("autenticacion");
		Registry registryGestor = LocateRegistry.getRegistry ();
		servicioGestorInterface = (ServicioGestorInterface) registryGestor.lookup ("gestor");
		String opt = "";
		do {
			System.out.println ("Elija una opcin:");
			System.out.println ("1 para registrarse");
			System.out.println ("2 para autenticarse");
			System.out.println ("3 para salir");
			opt = leerConsola ();
			switch (opt) {
				case "1": registrar (); break;
				case "2": autenticar (); break;
			}
		}
	while (!opt.equals ("3"));
	}
	private static void registrar () throws RemoteException {
		String texto;
		Registro registro = new Registro ();
		System.out.println ("Introducca su nombre");
		texto = leerConsola ();
		registro.setNombre (texto);
		System.out.println ("Introducca su email");
		texto = leerConsola ();
		registro.setEmail (texto);
		System.out.println ("Introducca su nick");
		texto = leerConsola ();
		registro.setNick (texto);
		System.out.println ("Introducca su password");
		texto = leerConsola ();
		registro.setPassword (texto);
		servicioAutenticacionInterface.leerRegistro (registro);
	}
	private static String leerConsola () {
		if (console != null) return console.readLine ();
		try {
			return reader.readLine ();
		}
		catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	private static void autenticar () throws RemoteException {	
	}
}